/* Copyright (C) 2008, Cyril Hu (cyrilhu@gmail.com)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA. */

#if defined(STR_DEBUG) || defined(STR_CKIDECHR_DEBUG)
#include <stdio.h>
#include <string.h>
#endif
#include <limits.h>
#include "ulbool.h"

/* Check for two or more identical chars in src,
 * return true on found, false on not found or empty string. */
bool ckidechr(const char *src0)
{
	const unsigned char *src = src0;
	int buf[UCHAR_MAX] = {0};
#ifdef STR_DEBUG
	int i;
	printf("\nchidechr(): str=\"%s\"\n", src);
#endif
	while(*src) {
		if(buf[*src] == 1) {
#ifdef STR_DEBUG
			printf("chidechr(): identical chars found @ buf[%d], changing to 2.", (int)*src);
			buf[*src]=2;
			for(i=0; i<UCHAR_MAX;i++) {
				if(i%40 == 0)
					puts("");
				printf("%d ", buf[i]);
			}
			puts("\nchidechr(): returning true.");
#endif
			return true;	
		}
		buf[*src++] = 1;
	}
#ifdef STR_DEBUG
	printf("chidechr(): identical chars not found.");
	for(i=0; i<UCHAR_MAX;i++) {
		if(i%40 == 0)
			puts("");
		printf("%d ", buf[i]);
	}
	puts("\nchidechr(): returning false.");
#endif
	return false;
}


#ifdef STR_CKIDECHR_DEBUG
int main(void)
{
	char buf[256]="ckidechr is fun! don\'t you think so?";
	ckidechr(buf);
	strcpy(buf, "");
	ckidechr(buf);
	strcpy(buf, "1234567890");
	ckidechr(buf);
	strcpy(buf, "0234567890");
	ckidechr(buf);
	strcpy(buf, "023456789\\\n\n");
	ckidechr(buf);
	return 0;
}
#endif
