/* Copyright (C) 2008, Cyril Hu (cyrilhu@gmail.com)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA. */

#if defined(STR_DEBUG) || defined(STR_MEMDUP_DEBUG)
#include <stdio.h>
#endif
#include <string.h>
#include <stdlib.h>

/* malloc() n bytes and memcpy(dst, src, n); 
 * return the pointer or NULL on failed malloc(). */
void *memdup(void *src, size_t n)
{
	void *p = malloc(n);
	if(p)
		memcpy(p, src, n);
	return p;
}

#ifdef STR_MEMDUP_DEBUG
int main(void)
{
	char *p="memdup, make a memory duplication."; 
	char *p1="memdup, makeplication."; 
	char *p2;
	p2=memdup(p, strlen(p));
	if(p2) { puts(p2); free(p2); }
	p2=memdup(p1, strlen(p1));
	if(p2) { puts(p2); free(p2); }
	return 0;
}
#endif
