/* Copyright (C) 2008, Cyril Hu (cyrilhu@gmail.com)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA. */

#if defined(STR_DEBUG) || defined(STR_STRCSTR_DEBUG)
#include <stdio.h>
#endif
#include <stddef.h>
#include <string.h>

/* Count times of sub occurrence(s) in src. */
size_t strcstr(const char *src, const char *sub)
{
	char *t;
	size_t lens = strlen(sub), cnt = 0;

#ifdef STR_DEBUG
	printf("strcstr(): src=\"%s\", ", src);
#endif
	if(lens == 0) 
		goto end;
	while(*src) {
		t = strstr(src, sub);
		if(t == NULL)
			break;
		++cnt, src = t + lens;
	}
end:
#ifdef STR_DEBUG
	printf("strcstr(): sub=\"%s\", times:%u\n", sub, (unsigned)cnt);
#endif
	return cnt;
}

#ifdef STR_STRCSTR_DEBUG
int main(void)
{
	char buf[512]="let\'s learn string counting, shall we?";
	strcstr(buf, "l");
	strcstr(buf, "s");
	strcstr(buf, "e");
	strcstr(buf, "let");
	strcstr(buf, "in");
	strcstr(buf, "ing");
	strcstr(buf, "y");
	strcstr(buf, "do it");
	strcstr(buf, "\'");
	strcstr(buf, "");
	strcstr("", "yes");
	strcstr("", "we");
	strcstr("", "");
	return 0;
}
#endif
