/* Copyright (C) 2008, Cyril Hu (cyrilhu@gmail.com)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA. */

#if defined(STR_DEBUG) || defined(STR_STRLDCPY_DEBUG)
#include <stdio.h>
#include <string.h>
#endif
#include <stddef.h>

/* Strcpy() with strlen(src) returned. */
size_t strldcpy(char *dst, const char *src)
{
	char *p = dst;
#ifdef STR_DEBUG
	printf("strldcpy(): strlen(dst)=%u,strlen(src)=%u\n", strlen(dst),strlen(src));
#endif
	while( (*p++ = *src++) != '\0')
		;
#ifdef STR_DEBUG
	printf("strldcpy(): strldcpy()=%u,dst=\"%s\",strlen(dst)=%u\n", p-dst-1,dst,strlen(dst));
#endif
	return p-dst-1;
}

#ifdef STR_STRLDCPY_DEBUG
int main(void)
{
	char buf[512]={0};
	char *p="strldcpy, both copy done and length returned."; 
	char *p2="";
	strldcpy(buf, p);
	strcpy(buf, "yes!!!");
	strldcpy(buf, p);
	strcpy(buf, "no!!!");
	strldcpy(buf, p2);
	strcpy(buf, "");
	strldcpy(buf, p2);
	return 0;
}
#endif
